#!/bin/bash

make_install_gsl()
{
    rm -rf ${TMPDIR}/*
    tar --no-same-owner -xzf ${SRCPATH}/src/gsl-2.6.tar.gz -C ${TMPDIR} >>$LOGFILE 2>&1
    if [ $? -ne 0 ]; then
        die "GSL uncompression failed, see $LOGFILE for details."
    fi
    pushd ${TMPDIR}/gsl* >/dev/null
    echo "configure GSL with gnu ..."
    ./configure --prefix=${PKGPATH} CC=/usr/bin/gcc CFLAGS="-O2 -fPIC" >>$LOGFILE 2>&1 || die "GSL configure failed, see $LOGFILE for details."
    echo "make GSL ..."
    make -j `grep cores /proc/cpuinfo | wc -l` >>$LOGFILE 2>&1 || die "GSL make failed, see $LOGFILE for details."
    echo "make install GSL ..."
    make install >>$LOGFILE 2>&1 || die "GSL make install failed, see $LOGFILE for details."
    popd >/dev/null
    rm -rf ${TMPDIR}/*
}

main()
{
    echo "Start to install $MODULE_NAME ......"
    CC=/usr/bin/gcc
    CXX=/usr/bin/g++
    F77=/usr/bin/gfortran
    FC=/usr/bin/gfortran
    make_install_gsl;
    echo "GSL (with gnu compiler $CC) installation ... OK"
}

main $@
