#!/bin/bash 

check_gcc()
{
    if which gcc >>$LOGFILE 2>&1; then
        gcc ${SRCPATH}/test/test.c -o ${TMPDIR}/a.out >>$LOGFILE 2>&1 && ${TMPDIR}/a.out >>$LOGFILE 2>&1
        if [ $? -eq 0 ]; then
            echo "Check gcc ... OK"
        else
            die "Check gcc ... failed, see $LOGFILE for details."
        fi
    else 
        die "Check gcc ... failed, please install related RPMs. (try: ${SRCPATH}/rpms)"
    fi
}

check_gxx()
{
    if which g++ >>$LOGFILE 2>&1; then
        g++ ${SRCPATH}/test/test.c -o ${TMPDIR}/a.out >>$LOGFILE 2>&1 && ${TMPDIR}/a.out >>$LOGFILE 2>&1
        if [ $? -eq 0 ]; then
            echo "Check g++ ... OK"
        else
            die "Check g++ ... failed, see $LOGFILE for details."
        fi
    else 
        die "Check g++ ... failed, please install related RPMs. (try: ${SRCPATH}/rpms)"
    fi
}

check_gfortran()
{
    if which gfortran >>$LOGFILE 2>&1; then
        gfortran ${SRCPATH}/test/test.f -o ${TMPDIR}/a.out >>$LOGFILE 2>&1 && ${TMPDIR}/a.out >>$LOGFILE 2>&1
        if [ $? -eq 0 ]; then
            echo "Check gfortran ... OK"
        else
            die "Check gfortran ... failed, see $LOGFILE for details."
        fi
    else 
        die "Check gfortran ... failed, please install related RPMs. (try: ${SRCPATH}/rpms)"
    fi
}

check_make()
{
    if which make >>$LOGFILE 2>&1; then
        echo "Check make ... OK"
    else
        die "Check make ... failed, please install related RPMs. (try: ${SRCPATH}/rpms)"
    fi
}

main()
{
    rm -rf ${TMPDIR}/*
    check_gcc;
    check_gxx;
    check_gfortran;
    check_make;
    rm -rf ${TMPDIR}/*
}

main $@
