#%Module1.0

module-whatis       "Sets up the Open MPI Library environment"

conflict            mpi

set hpcx_dir        __PKGPATH__
set hpcx_mpi_dir    __PKGPATH__

setenv HPCX_DIR             $hpcx_dir
setenv HPCX_HOME            $hpcx_dir
setenv HPCX_UCX_DIR         $hpcx_dir/external_libs/ucx/1.17.0
setenv HPCX_MPI_DIR         $hpcx_mpi_dir
setenv HPCX_OSHMEM_DIR      $hpcx_mpi_dir

prepend-path    PATH            $hpcx_dir/external_libs/ucx/1.17.0/bin
prepend-path    LD_LIBRARY_PATH $hpcx_dir/external_libs/ucx/1.17.0/lib
prepend-path    LD_LIBRARY_PATH $hpcx_dir/external_libs/ucx/1.17.0/lib/ucx
prepend-path    LIBRARY_PATH    $hpcx_dir/external_libs/ucx/1.17.0/lib
prepend-path    LIBRARY_PATH    $hpcx_dir/external_libs/ucx/1.17.0/lib/ucx
prepend-path    CPATH           $hpcx_dir/external_libs/ucx/1.17.0/include
prepend-path    CPATH           $hpcx_mpi_dir/include
prepend-path    PKG_CONFIG_PATH $hpcx_dir/external_libs/ucx/1.17.0/lib/pkgconfig
prepend-path    PKG_CONFIG_PATH $hpcx_dir/lib/pkgconfig
prepend-path    MANPATH         $hpcx_mpi_dir/share/man

# Adding MPI runtime
setenv OPAL_PREFIX  $hpcx_mpi_dir
setenv OMPI_HOME    $hpcx_mpi_dir
setenv MPI_HOME     $hpcx_mpi_dir
setenv OSHMEM_HOME  $hpcx_mpi_dir
setenv SHMEM_HOME   $hpcx_mpi_dir

prepend-path    PATH            $hpcx_mpi_dir/bin
prepend-path    LD_LIBRARY_PATH $hpcx_mpi_dir/lib
prepend-path    LIBRARY_PATH    $hpcx_mpi_dir/lib
prepend-path    INCLUDE         $hpcx_mpi_dir/include

# Adding OMPI runtime parameters
setenv UCX_RNDV_THRESH      16384
setenv UCX_ZCOPY_THRESH     16384
setenv UCX_MAX_EAGER_LANES  1
setenv UCX_MAX_RNDV_LANES   1
setenv UCX_DC_MLX5_TIMEOUT  1000ms
setenv UCX_RC_MLX5_TIMEOUT  1000ms
setenv OMPI_MCA_btl_openib_warn_default_gid_prefix             0
setenv OMPI_MCA_btl_openib_warn_no_device_params_found         0
setenv OMPI_MCA_btl         "^uct"
setenv OMPI_MCA_pml         "ucx"
setenv OMPI_MCA_coll_hcoll_enable                              0
setenv OMPI_MCA_coll_hcoll_np                                  0
setenv OMPI_MCA_io          romio321
