#!/usr/bin/bash

find_gnu_env()
{
    #check if gnu compiler is in env
    which gcc 2>&1;
    if [ $? -eq 0 ];then
        export MPIRUN="mpirun --allow-run-as-root"
        return 0;
    fi

    die "GNU does not installed, please install GNU Compiler firstly!";
}

check_mpicc()
{
    if which mpicc 2>&1; then
        mpicc ${SRCPATH}/test/test_mpi.c -o ${TMPDIR}/a.out
	${MPIRUN} -np 1 ${TMPDIR}/a.out  2>&1
        if [ $? -eq 0 ]; then
            echo "Check mpicc ... OK"
        else
            die "Check mpicc ... failed."
        fi
    else
        die "Check mpicc ... failed, see for details."
    fi
}

check_mpicxx()
{
    if which mpicxx  2>&1; then
        mpicxx -show 2>&1
        mpicxx ${SRCPATH}/test/test_mpi.cxx -o ${TMPDIR}/a.out  2>&1 && $MPIRUN -np 1 ${TMPDIR}/a.out 2>&1
        if [ $? -eq 0 ]; then
            echo "Check mpicxx ... OK"
        else
            die "Check mpicxx ... failed."
        fi
    else
        die "Check mpicxx ... failed."
    fi
}

check_mpif77()
{
    if which mpif77  2>&1; then
        mpif77 -show  2>&1
        mpif77 ${SRCPATH}/test/test_mpi.f -o ${TMPDIR}/a.out 2>&1 && $MPIRUN -np 1 ${TMPDIR}/a.out  2>&1
        if [ $? -eq 0 ]; then
            echo "Check mpif77 ... OK"
        else
            die "Check mpif77 ... failed."
        fi
    else
        die "Check mpif77 ... failed."
    fi
}

check_mpif90()
{
    if which mpif90 2>&1; then
        mpif90 -show 2>&1
        mpif90 ${SRCPATH}/test/test_mpi.f -o ${TMPDIR}/a.out  2>&1 && $MPIRUN -np 1 ${TMPDIR}/a.out 2>&1
        if [ $? -eq 0 ]; then
            echo "Check mpif90 ... OK"
        else
            die "Check mpif90 ... failed."
        fi
    else
        die "Check mpif90 ... failed."
    fi
}

main()
{
    rm -rf ${TMPDIR}/*
    find_gnu_env;
    check_mpicc;
    check_mpicxx;
    check_mpif77;
    check_mpif90;
    rm -rf ${TMPDIR}/*
}


main $@
